% Esempio polinomi di Lagrange di ordine 3.

ngrad = 3;                      % Grado del polinomio di interpolazione
% xi = linspace(0,1,ngrad+1)';  % Punti definizione polinomio interpolazione
xi = [5 -7 -6 0]';
fi = [1 -23 -54 -954]';
np = 60;                        % Numero di punti di valutazione dei polinomi
xval = linspace(min(xi),max(xi),np)';        % Coordinate su cui valutare i polinomi
L = zeros(np,ngrad+1);          % La colonna i-esima contiene L_i(xval)
for i=1:ngrad+1
    for p=1:np,
        x = xval(p);
        Lval = 1;
        for j=1:ngrad+1
            if(j ~= i)
                Lval = Lval*(x-xi(j))/(xi(i)-xi(j));
            end
        end
        L(p,i) = Lval;
    end
end

figure(1);
h = plot(xval,L);
set(h,'LineWidth',2);

figure(2);
plot(xval,sum(L,2))

yval = L*fi;
figure(3);
h = plot(xval,yval)
set(h,'LineWidth',2);
hold on
h = plot(xi,fi,'or');
set(h,'LineWidth',5);
hold off

